<?php

namespace Drupal\graphapi\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Configure GraphAPI settings.
 */
class SettingsForm extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'graphapi_settings';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->configFactory->get('graphapi.site');

    $form['graphviz'] = array(
      '#type' => 'details',
      '#title' => t('Graphviz settings'),
    );
    $form['graphviz']['graphviz_path'] = array(
      '#type' => 'textfield',
      '#title' => t('Path to Graphviz dot executable'),
      '#default_value' => $config->get('graphviz_path'),
      '#required' => TRUE
    );
    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
    parent::validateForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $this->configFactory->get('graphapi.site')
      ->set('graphviz_path', $form_state['values']['graphviz_path'])
      ->save();

    parent::submitForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return ['graphapi.site'];
  }

}
